/*
  AntiRight
  (c) 2003-2004 Jeffrey Bedard
  jefbed@e-list.net
   
  This file is part of AntiRight.
   
  AntiRight is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
   
  AntiRight is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
   
  You should have received a copy of the GNU General Public License
  along with AntiRight; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "arshell.h"

void
arshell_default_menubar_action(Widget mainwindow_widget,
			       struct antiright_menubar_structure* menubar)
{
  (*menubar)=antiright_defined_menubar(mainwindow_widget, NULL);
}

void
arshell_handle_menubar_sub_arguments(int* counter_int,
				     char** argv,
				     Widget mainwindow_widget,
				     struct antiright_menubar_structure* 
				     menubar)
{
  switch(argv[(*counter_int)][3])
    {
    case 'f':
      {
	(*counter_int)++;
	arshell_optioned_button(menubar->file_widget, arshell_system_cb,
				argv[(*counter_int)]);
      }
      break;
    case 'e':
      (*counter_int)++;
      if((arshell_text_widget != NULL))
	{
	  if(menubar->edit_widget==NULL)
	    {
	      antiright_edit_menu(menubar->menubar_widget, arshell_text_widget);
	    }
	  arshell_optioned_button(menubar->file_widget, arshell_system_cb,
				  argv[(*counter_int)]);
	}
      break;
    case 'v':
      (*counter_int)++;
      	arshell_optioned_button(menubar->file_widget, arshell_system_cb,
				argv[(*counter_int)]);
      break;
    case 'h':
      (*counter_int)++;
      arshell_optioned_button(menubar->file_widget, arshell_system_cb,
			      argv[(*counter_int)]);
      break;
    default:
      arshell_default_menubar_action(mainwindow_widget, menubar);
      break;
    }
}

void
arshell_handle_updating_argument(int* counter_int,
				 char** argv)
{
  /* FIXME: Make this more extensive, allowing
     updating of the work area, etc.  */
  (*counter_int)++;
  XtAppAddTimeOut(app_context,
		  1000,
		  arshell_update_work_procedure,
		  argv[(*counter_int)]);
}

void
arshell_handle_command_line_arguments(int* argc,
				      char** argv,
				      Widget* mainwindow_widget,
				      struct antiright_menubar_structure*
				      menubar)
{
  Widget row_manager_widget=NULL;
  Widget row_widget;
  int counter_int;
  int row_counter_int=0;
  int rows_int=6;

  for(counter_int=1; counter_int < (*argc); counter_int++)
  {
      if(argv[counter_int][0] == '-')
	{
	  /* The code for the case statements should be clear as to
	     its action and fully indirected through extraction.  */
	  switch (argv[counter_int][1])
	    {
	    case 'A': /* This adds a widget.  */
	      switch(argv[counter_int][2])
		{
		case 'C':
		  arshell_color_widget((*mainwindow_widget));
		  break;
		case 'l': /* Add a label.  */
		  counter_int++;
		  antiright_label((*mainwindow_widget), argv[counter_int]);
		  break;
		case 'm':
		  arshell_handle_menubar_sub_arguments(&counter_int, 
						       argv,
						       (*mainwindow_widget),
						       menubar);
		  break;
		case 's': /* Create a status area.  */
		  antiright_create_status_bar((*mainwindow_widget));
		  break;
		case 't': /* Add a text field.  */
		  counter_int++;
		  arshell_create_default_text_entry((*mainwindow_widget), 
						    &counter_int, argv); 

		  break;
		case 'w': /* Add a work area scrolled text.  */
		  arshell_create_text_work_area((*mainwindow_widget), menubar);
		  break;
		}
	      break;
	    case 'E': /* Exit when a button is pressed.  */
	      arshell_exit_on_action_flag=True;
	      break;
	    case 'p': /* Input pipe operations.  */
	      arshell_set_work_area_from_stdin();
	      break;
	    case 'r':
	      arshell_set_rows(&counter_int, 
			       argv, 
			       &rows_int, 
			       &row_counter_int);
	      break;
	    case 'U': 
	      arshell_handle_updating_argument(&counter_int, argv);
	      break;
	    case 'W': /* This sets the window title and the work
			 filename.  I know this is a weird way to do
			 things, but it keeps things small and is
			 actually quite practical.  */
	      counter_int++;
	      strncpy(arshell_filename, argv[counter_int], 255);
	      antiright_set_title(argv[counter_int]);
	      break;
	    default:
	      arshell_usage();
	      break;
	    }
	}
      else
	{
	  arshell_row_layout((*mainwindow_widget), 
			     &row_manager_widget, 
			     &row_widget, 
			     &row_counter_int, rows_int);
	  arshell_optioned_button(row_widget, 
				  arshell_system_cb, 
				  argv[counter_int]);
	}
    }
}
